/*  _______________________________________________________________________
 *
 *                        RDPARM/PTRAJ: 2008
 *  _______________________________________________________________________
 *
 *  This file is part of rdparm/ptraj.
 *
 *  rdparm/ptraj is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  rdparm/ptraj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You can receive a copy of the GNU General Public License from
 *  http://www.gnu.org or by writing to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  ________________________________________________________________________
 *
 *  CVS tracking:
 *
 *  $Header: /thr/loyd/case/cvsroot/amber10/src/ptraj/rms.h,v 9.2 2008/02/15 22:45:21 tom_cheatham Exp $
 *
 *  Revision: $Revision: 9.2 $
 *  Date: $Date: 2008/02/15 22:45:21 $
 *  Last checked in by $Author: tom_cheatham $
 *  ________________________________________________________________________
 *
 *
 *  CONTACT INFO: To learn who the code developers are, who to contact for
 *  more information, and to know what version of the code this is, refer
 *  to the CVS information and the include files (contributors.h && version.h)
 *
 */

#include "contributors.h"
#include "version.h"

/*  ________________________________________________________________________
 */



/* Header file for rms.c */

#ifndef RMS_MODULE
#  ifdef __STDC__

double rms(int n, int mode, double *weights, int *mask,
	   double *toFitX, double *toFitY, double *toFitZ,
	   double *X, double *Y, double *Z, 
	   double rotation[3][3], double translation[3], int fit);

double rmsf(int n, int mode, double *weights, int *mask,
	   float *toFitX, float *toFitY, float *toFitZ,
	   float *X, float *Y, float *Z, 
	   float rotation[3][3], float translation[3], int fit);
#  else

double rms();
double rmsf();

#  endif
#endif


